package com.jzlife.report.controller;

import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.dao.douyin.DouyinServantMapper;
import com.jzlife.report.util.ResponseUtil;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 抖音私域服务力报表
 */
@RestController
@RequestMapping("douyinServant")
public class DouyinServantController {

    @Autowired
    private DouyinServantMapper douyinServantMapper;


    @ApiOperation(value = "抖音私域服务力相关报表", httpMethod = "GET", notes = "在线服务人员汇总")
    @GetMapping("servant")
    @LogRecordFiled(funName = "在线服务人员汇总")
    public Object getServant() throws Exception {
        return ResponseUtil.ok(douyinServantMapper.getServant());
    }

    @ApiOperation(value = "抖音私域服务力相关报表", httpMethod = "GET", notes = "获取城市14天库存利用率")
    @GetMapping("cityStock")
    @LogRecordFiled(funName = "获取城市14天库存利用率")
    public Object getCityStock() throws Exception {
        return ResponseUtil.ok(douyinServantMapper.getCityStock());
    }

    @ApiOperation(value = "抖音私域服务力相关报表", httpMethod = "GET", notes = "获取服务站1-15天各阶段库存利用率")
    @GetMapping("stationStock")
    @LogRecordFiled(funName = "获取服务站1-15天各阶段库存利用率")
    public Object getStationStock(String city) throws Exception {
        return ResponseUtil.ok(douyinServantMapper.getStationStock(city));
    }
}
