package com.jzlife.report.controller;

import com.jzlife.report.service.nurse.SanSaoService;
import com.jzlife.report.vo.NannyVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * 三嫂业务报表
 */
@RestController
@RequestMapping(value = "nanny")
@Api(value = "nanny", description = "三嫂报表")
public class NannyController {

    @Autowired
    private SanSaoService sanSaoService;

    @ApiOperation("获取三嫂业务统计数据")
    @GetMapping("getData")
    public Object getData(){
        return sanSaoService.getSanSaoData();
    }

    @ApiOperation("获取三嫂业务城市统计数据")
    @PostMapping("getCityData")
    public Object getCityData(@RequestBody NannyVo nannyVo){
        return sanSaoService.getCityData(nannyVo);
    }


    @ApiOperation("获取三嫂服务模式统计数据")
    @PostMapping("getServiceModelData")
    public Object getServiceModelData(@RequestBody NannyVo nannyVo){
        return sanSaoService.getServiceModelData(nannyVo);
    }
    @ApiOperation("获取三嫂业务来源")
    @GetMapping("getSource")
    public Object getSource(){
        return sanSaoService.getSource();
    }

}
