package com.jzlife.report.controller;

import com.jzlife.report.dao.hmorder.DiRReportMapper;
import com.jzlife.report.dao.nurse.SysCityMapper;
import com.jzlife.report.entity.hmorder.DiRReport;
import com.jzlife.report.entity.nurse.SysCity;
import com.jzlife.report.service.hmorder.DiReportService;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.vo.PersonWorkAvgVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping(value = "personWorkAvg")
public class PersonWorkAvgController {

	@Autowired
	DiRReportMapper diRReportMapper;

	@Autowired
	SysCityMapper cityMapper;

	@Autowired
	DiReportService diReportService;

	public static DateFormat dfd = new SimpleDateFormat("yyyy-MM-dd");

	@GetMapping("testReport")
	public Object testReport(String dataTime) {
		diReportService.generationReport(dataTime);
		return "ok";
	}

	@GetMapping("getReportData")
	public Object getReportData(String startTime, String endTime, int type) {
		List<String> tempListDays = new ArrayList<String>();// AccountDate.getEveryday(startTime, endTime);

		List<PersonWorkAvgVo> pwaList = new ArrayList<PersonWorkAvgVo>();
		List<String> timeList = new ArrayList<String>();

		List<SysCity> cityal = cityMapper.selectAll();
		for (SysCity c : cityal) {
			List<DiRReport> listreport = diRReportMapper.selectReportList(c.getId(), type, startTime, endTime);

			PersonWorkAvgVo gd = new PersonWorkAvgVo();
			gd.setName("工单数-" + c.getCityName());
			gd.setType("bar");

			PersonWorkAvgVo gs = new PersonWorkAvgVo();
			gs.setName("人均工时-" + c.getCityName());
			gs.setType("line");

			if (type == 2) {
				gd.setName(gd.getName() + "品类");
				gs.setName(gs.getName() + "品类");
			}
			if (type == 3) {
				gd.setName(gd.getName() + "日保");
				gs.setName(gs.getName() + "日保");
			}

			List<String> gdList = new ArrayList<String>();// 每日订单量
			List<String> gsList = new ArrayList<String>();// 人均工时数
			for (DiRReport r : listreport) {
				gdList.add(r.getWorkOrderSum().toString());
				gsList.add(r.getPersonAvgTime().toString());

				String data = dfd.format(r.getDays());
				if (!tempListDays.contains(data)) {
					tempListDays.add(data);
				}

			}
			gd.setData(gdList);
			gs.setData(gsList);

			pwaList.add(gd);
			pwaList.add(gs);
		}

		for (String result : tempListDays) {
			timeList.add(Integer.parseInt(result.substring(5, 7)) + "/" + Integer.parseInt(result.substring(8, 10)));
		}

		Map<String, Object> data = new HashMap<String, Object>();
		data.put("timeList", timeList);
		data.put("pwaList", pwaList);

		return ResponseUtil.ok(data);
	}

}
