package com.jzlife.report.controller;

import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.dto.ReportOldCustomerRebuy;
import com.jzlife.report.dto.ReportSalesNewcustomerV3;
import com.jzlife.report.dto.SysExportLogDto;
import com.jzlife.report.service.ExportLogRecordService;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.util.page.BeanUtil;
import com.jzlife.report.util.page.PagedResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@Api(value = "Report-Controller", description = "报表日志查看")
@RestController
@RequestMapping(value = "reportLog")
public class ReportLogController {

    @Autowired
    private ExportLogRecordService exportLogRecordService;

    @ApiOperation("报表日志查看")
    @GetMapping("log")
    @LogRecordFiled(funName = "报表日志查看")
    public Object log(@RequestParam(defaultValue = "1") Integer pageIndex,
                      @RequestParam(defaultValue = "50") Integer pageSize,
                      String startDate, String endDate,
                      @RequestParam(defaultValue = "false") Boolean isExport,
                      HttpServletResponse response, HttpServletRequest request) throws Exception {
        endDate=endDate+" 23:59:59";
        if (isExport == false) {
            List<SysExportLogDto> list = exportLogRecordService.selectByTime(startDate, endDate, pageIndex, pageSize);
            return ResponseUtil.ok(BeanUtil.toPagedResult(list));
        } else {
            List<SysExportLogDto> list = exportLogRecordService.selectByTime(startDate, endDate, 1, 10000);
            ExcelUtils.exportExcel(list, null, "Sheet1", SysExportLogDto.class, "报表浏览日志.xls", response);
            return null;
        }

    }
}
