package com.jzlife.report.controller;

import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.entity.reports.TTempClue;
import com.jzlife.report.service.nurse.SanSaoService;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.vo.SanSaoVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

@RestController
@RequestMapping("sansao")
@Api(value = "SanSaoController", description = "三嫂业务")
public class SanSaoController {

    @Autowired
    private SanSaoService sanSaoService;


    @ApiOperation(value = "三嫂合同", httpMethod = "POST")
    @PostMapping("sansaoContractList")
    @LogRecordFiled(funName = "三嫂合同")
    public Object sansaoContractList(@Validated @RequestBody SanSaoVo sanSaoVo, HttpServletResponse response) throws Exception {
        if (null!=sanSaoVo.getExportFlag()&&sanSaoVo.getExportFlag()) {
            List<TTempClue> clues = sanSaoService.selectSanSaoContractListNoPage(sanSaoVo);
            ExcelUtils.exportExcel(clues, "三嫂合同", "三嫂合同", TTempClue.class, "三嫂合同", response);
            return null;
        }
        return ResponseUtil.ok(sanSaoService.selectSanSaoContractList(sanSaoVo));
    }
}
