package com.jzlife.report.controller;


import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.anno.LogRecordFiled;
import com.jzlife.report.dao.nurse.Report30daysProductStocksResultMapper;
import com.jzlife.report.dao.reports.CrmOrderBookCpMapper;
import com.jzlife.report.dto.Report30daysProductStocks;
import com.jzlife.report.dto.kaocf.KaoSales;
import com.jzlife.report.entity.reports.CrmOrderBookCp;
import com.jzlife.report.excelExport.*;
import com.jzlife.report.service.newreport.ServicePowerReportService;
import com.jzlife.report.util.ExcelUtils;
import com.jzlife.report.util.ResponseUtil;
import com.jzlife.report.util.excel.ExcelXlsxReader;
import com.jzlife.report.vo.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotNull;
import java.io.InputStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;

@Api(value = "服务力看板", description = "服务力看板")
@RestController
@RequestMapping(value = "report")
public class ServicePowerReportController {


    @Autowired
    private ServicePowerReportService service;

    @Autowired
    Report30daysProductStocksResultMapper daysProductStocksResultMapper;
    
    @Autowired
    CrmOrderBookCpMapper crmOrderBookCpMapper;

//    @ApiOperation(value = "导入各城市14天库存率", httpMethod = "POST", notes = "导入各城市14天库存率")
//    @PostMapping("importCity14DaysStockRadio")
//    @LogRecordFiled(funName = "导入各城市14天库存率")
//    public Object importCity14DaysStackRadio(@RequestParam("file") MultipartFile file) {
//        try {
//            //错误maps
//            Map<Integer, String> errorMap = new HashMap<>();
//            //错误列表
//            List<DaysStackRadioVo> errors = new ArrayList<>();
//            //站点数据列表
//            List<DaysStackRadioVo> stations = ExcelPOIUtils.readExc(file, DaysStackRadioVo.class, errorMap, errors, 11, 2);
//            //保存录入信息
//            Map<String, Object> result = service.importData(stations);
//            HashMap<String, Object> maps = new HashMap<>();
//            //在成功的列表中去除失败的数据
//            if (result.containsKey("fail")) {
//                List<String> of = (List<String>) result.get("fail");
//                maps.put("otherFail", of);
//            }
//            maps.put("succ", stations);
//            maps.put("fail", errorMap);
//            return ResponseUtil.ok("导入成功", maps);
//        } catch (Exception e) {
//            return ResponseUtil.fail400(e.getMessage());
//        }
//    }
//
//
//    @ApiOperation(value = "导入近30天商品库存", httpMethod = "POST", notes = "导入近30天商品库存")
//    @PostMapping("import30DaysProductStock")
//    @LogRecordFiled(funName = "导入近30天商品库存")
//    public Object import30DaysProductStock(@RequestParam("file") MultipartFile file, HttpServletRequest request) {
//        Integer userId = (Integer) request.getAttribute("userId");
//        String s = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd")) + "_userId_" + userId + "_01";
//        Report30daysProductStocksResult result1 = daysProductStocksResultMapper.selectBySerialNo(s);
//        if (null != result1) {
//            return ResponseUtil.fail400("今天已成功导入过，请勿重复导入！");
//        }
//        try {
//            new Thread(() -> {
//                {
//                    try {
//                        List<Report30daysProductStocks> productStocks = readExcelXlsx(file.getInputStream());
//                        service.import30DaysProductStock(productStocks, s);
//                    } catch (Exception e) {
//                        e.printStackTrace();
//                    }
//                }
//            }).start();
//            HashMap<String, Object> maps = new HashMap<>();
//            maps.put("serialNo", s);
//            Report30daysProductStocksResult result = new Report30daysProductStocksResult();
//            result.setSerialNo(s);
//            result.setResultType(2);
//            result.setCreateTime(new Date());
//            daysProductStocksResultMapper.insert(result);
//            return ResponseUtil.ok("后台导入中,请稍后再查看", maps);
//        } catch (Exception e) {
//            return ResponseUtil.fail400(e.getMessage());
//        }
//    }
//
//
//    @ApiOperation(value = "查询导入30天商品库存结果", httpMethod = "GET", notes = "查询导入30天商品库存结果")
//    @GetMapping("import30DaysProductStockResult")
//    @LogRecordFiled(funName = "查询导入30天商品库存结果")
//    public Object import30DaysProductStockResult(@RequestParam("serialNo") String serialNo) {
//        return service.get30DaysProductStockResult(serialNo);
//    }


    @ApiOperation(value = "服务力工单明细", httpMethod = "POST", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @PostMapping("servicePowerTicketDetail")
    @LogRecordFiled(funName = "服务力工单明细")
    public Object servicePowerTicketDetail(@Validated @RequestBody DayReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerTicketDetail(vo);
        return ResponseUtil.ok(data);
    }


    @ApiOperation(value = "服务力工单明细导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerTicketDetailExport")
    @LogRecordFiled(funName = "服务力工单明细导出")
    public void servicePowerTicketDetailExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            @RequestParam(value = "sourceType", required = false) String sourceType,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        vo.setSourceType(sourceType);
        List<ServicePowerTicketDetailDTO> dtoList = service.servicePowerTicketDetailNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-工单明细", "工单明细", ServicePowerTicketDetailDTO.class, "工单明细", response);
        }
    }


    @ApiOperation(value = "服务力工单汇总", httpMethod = "POST", notes = "时间格式为：yyyy-MM-dd 使用盒马服务站")
    @PostMapping("servicePowerTicketInfo")
    @LogRecordFiled(funName = "服务力工单汇总")
    public Object servicePowerTicketInfo(@Validated @RequestBody DayReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerTicketInfo(vo);
        return ResponseUtil.ok(data);
    }


    @ApiOperation(value = "服务力工单汇总导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerTicketInfoExport")
    @LogRecordFiled(funName = "服务力工单明细导出")
    public void servicePowerTicketInfoExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        List<ServicePowerTicketInfoDTO> dtoList = service.servicePowerTicketInfoNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-工单汇总", "工单汇总",
                    ServicePowerTicketInfoDTO.class, "工单汇总", response);
        }
    }

    @NotNull
    private DayReportBaseVo setRequestInfo(String city, String startTime, String endTime, String serviceStation, HttpServletRequest request) {
        DayReportBaseVo vo = new DayReportBaseVo();
        vo.setCity(city);
        vo.setStartTime(startTime);
        vo.setEndTime(endTime);
        vo.setServiceStation(serviceStation);
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        return vo;
    }

    @ApiOperation(value = "服务力商家信息", httpMethod = "POST", notes = "时间格式为：yyyy-MM-dd 使用自家服务站")
    @PostMapping("servicePowerServerInfo")
    @LogRecordFiled(funName = "服务力商家信息")
    public Object servicePowerServerInfo(@Validated @RequestBody DayReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerServerInfo(vo);
        return ResponseUtil.ok(data);
    }


    @ApiOperation(value = "服务力商家信息导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerServerInfoExport")
    @LogRecordFiled(funName = "服务力商家信息导出")
    public void servicePowerServerInfoExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        List<ServicePowerServerInfoDTO> dtoList = service.servicePowerServerInfoNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-商家信息", "商家信息",
                    ServicePowerServerInfoDTO.class, "商家信息", response);
        }
    }

    @ApiOperation(value = "服务力当月人员汇总", httpMethod = "POST", notes = "时间格式为：yyyy-MM-dd 使用自家服务站")
    @PostMapping("servicePowerStationPersonInfo")
    @LogRecordFiled(funName = "服务力当月人员汇总")
    public Object servicePowerStationPersonInfo(@Validated @RequestBody DayReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerStationPersonInfo(vo);
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "服务力当月人员汇总导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerStationPersonInfoExport")
    @LogRecordFiled(funName = "服务力当月人员汇总导出")
    public void servicePowerStationPersonInfoExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        List<ServicePowerStationPersonInfoDTO> dtoList = service.servicePowerStationPersonInfoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-服务站当月人员汇总", "服务站当月人员汇总",
                    ServicePowerStationPersonInfoDTO.class, "服务站当月人员汇总", response);
        }
    }

    @ApiOperation(value = "住宿费", httpMethod = "POST", notes = "时间格式为：yyyy-MM 使用自家服务站")
    @PostMapping("servicePowerRentFee")
    @LogRecordFiled(funName = "住宿费")
    public Object servicePowerRentFee(@Validated @RequestBody ReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerRentFee(vo);
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "住宿费导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerRentFeeExport")
    @LogRecordFiled(funName = "住宿费导出")
    public void servicePowerRentFee(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            @RequestParam(value = "workerName", required = false) String workerName,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        vo.setWorkerName(workerName);
        List<ServicePowerRentFeeDTO> dtoList = service.servicePowerRentFeeNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-住宿费", "住宿费",
                    ServicePowerRentFeeDTO.class, "住宿费", response);
        }
    }

    @ApiOperation(value = "宿舍长补贴", httpMethod = "POST", notes = "时间格式为：yyyy-MM 使用自家服务站")
    @PostMapping("servicePowerWornSubsidies")
    @LogRecordFiled(funName = "宿舍长补贴")
    public Object servicePowerWornSubsidies(@Validated @RequestBody ReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerWornSubsidies(vo);
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "宿舍长补贴导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerWornSubsidiesExport")
    @LogRecordFiled(funName = "宿舍长补贴导出")
    public void servicePowerWornSubsidiesExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            @RequestParam(value = "workerName", required = false) String workerName,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        vo.setWorkerName(workerName);
        List<ServicePowerWornSubsidiesDTO> dtoList = service.servicePowerWornSubsidiesNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-宿舍长补贴", "宿舍长补贴",
                    ServicePowerWornSubsidiesDTO.class, "宿舍长补贴", response);
        }
    }

    @ApiOperation(value = "师傅奖励", httpMethod = "POST", notes = "时间格式为：yyyy-MM 使用自家服务站")
    @PostMapping("servicePowerTeacherReward")
    @LogRecordFiled(funName = "师傅奖励")
    public Object servicePowerTeacherReward(@Validated @RequestBody ReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerTeacherReward(vo);
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "师傅奖励导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerTeacherRewardExport")
    @LogRecordFiled(funName = "师傅奖励导出")
    public void servicePowerTeacherRewardExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            @RequestParam(value = "workerName", required = false) String workerName,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {
        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        vo.setWorkerName(workerName);
        List<ServicePowerTeacherRewardDTO> dtoList = service.servicePowerTeacherRewardNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-师傅奖励", "师傅奖励",
                    ServicePowerTeacherRewardDTO.class, "师傅奖励", response);
        }
    }

    @ApiOperation(value = "跟单奖励", httpMethod = "POST", notes = "时间格式为：yyyy-MM-dd 使用自家服务站")
    @PostMapping("servicePowerOrderReward")
    @LogRecordFiled(funName = "跟单奖励")
    public Object servicePowerOrderReward(@Validated @RequestBody ReportBaseVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        PageInfo<Map<String, Object>> data = service.servicePowerOrderReward(vo);
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "跟单奖励导出", httpMethod = "GET", notes = "时间格式为：yyyy-MM-dd,使用 盒马服务站")
    @GetMapping("servicePowerOrderRewardExport")
    @LogRecordFiled(funName = "跟单奖励导出")
    public void servicePowerOrderRewardExport(
            @RequestParam(value = "startTime") String startTime,
            @RequestParam(value = "endTime") String endTime,
            @RequestParam(value = "city", required = false) String city,
            @RequestParam(value = "serviceStation", required = false) String serviceStation,
            @RequestParam(value = "workerName", required = false) String workerName,
            HttpServletRequest request,
            HttpServletResponse response
    ) throws Exception {

        DayReportBaseVo vo = setRequestInfo(city, startTime, endTime, serviceStation, request);
        vo.setWorkerName(workerName);
        List<ServicePowerOrderRewardDTO> dtoList = service.servicePowerOrderRewardExportNoPage(vo);
        if (dtoList.size() > 0) {
            ExcelUtils.exportExcel(dtoList, "服务力-跟单奖励", "跟单奖励",
                    ServicePowerOrderRewardDTO.class, "跟单奖励", response);
        }
    }

    public static List<Report30daysProductStocks> readExcelXlsx(InputStream in) throws Exception {
        ExcelXlsxReader excelXls = new ExcelXlsxReader();
        List<List<String>> dataList = excelXls.process(in);
        List<Report30daysProductStocks> stations = new ArrayList<>();
        for (int i = 0; i < dataList.size(); i++) {
            if (i > 0) {
                List<String> e = dataList.get(i);
                Report30daysProductStocks aa = new Report30daysProductStocks();
                aa.setStockDate(e.get(0));
                aa.setSupplier(e.get(1));
                aa.setShopName(e.get(2));
                aa.setSku(Long.valueOf(e.get(3)));
                aa.setProductId(Long.valueOf(e.get(4)));
                aa.setProductName(e.get(5));
                aa.setTimeStamp(e.get(6));
                aa.setTotalCount(Integer.parseInt(e.get(7)));
                aa.setFreeCount(Integer.parseInt(e.get(8)));
                stations.add(aa);
            }
        }
        return stations;
    }


    // 服务力三期新增
    @ApiOperation(value = "服务力14天库存", httpMethod = "GET", notes = " t-1 ~ t+12")
    @GetMapping("service14DayStock")
    @LogRecordFiled(funName = "服务力14天库存")
    public Object service14DayStock(String city, HttpServletRequest request) {
        if (StringUtils.isEmpty(city)) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                city = citys;
            }
        }
        List<Map<String, Object>> data = service.service14DayStock(city, request.getHeader("userId"));
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "服务力指标&服务站指标", httpMethod = "GET", notes = "yyyy-MM 格式")
    @GetMapping("serviceGoalData")
    @LogRecordFiled(funName = "服务力指标&服务站指标")
    public Object serviceGoalData(@RequestParam("month") String month, HttpServletRequest request, String city) {
        if (StringUtils.isEmpty(city)) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                city = citys;
            }
        }
        String userId = request.getHeader("userId");
        Map<String, Object> data = service.serviceGoalData(month, userId, city);
        return ResponseUtil.ok(data);
    }


    @ApiOperation(value = "服务站与门店库存", httpMethod = "POST", notes = "使用盒马服务站")
    @PostMapping("stationAndShopStock")
    @LogRecordFiled(funName = "服务站与门店库存")
    public Object stationAndShopStock(@Validated @RequestBody ReportStationAndShopVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        Map<String, Object> data = service.stationAndShopStock(vo);
        return ResponseUtil.ok(data);
    }

    @ApiOperation(value = "订单热力图", httpMethod = "POST", notes = "使用盒马服务站")
    @PostMapping("orderHeatMap")
    @LogRecordFiled(funName = "订单热力图")
    public Object orderHeatMap(@Validated @RequestBody BaseRequestVo vo, HttpServletRequest request) {
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        Map<String, Object> data = service.createOrderHeatMap(vo);
        return ResponseUtil.ok(data);
    }


    @ApiOperation(value = "保洁人均单量&品类人均工时", httpMethod = "POST", notes = "使用盒马服务站")
    @PostMapping("CleanPerCapitalOrderQuality")
    @LogRecordFiled(funName = "保洁人均单量&品类人均工时")
    public Object CleanPerCapitalOrderQuality(@Validated @RequestBody ReportCleanPerCaptchaOrderQualityVo vo, HttpServletRequest request) {
        if (vo.getTimeType() == 1 && (StringUtils.isEmpty(vo.getStartMonth()) || StringUtils.isEmpty(vo.getEndMonth()))) {
            return ResponseUtil.fail400("开始结束月份不可为空");
        }
        if (vo.getTimeType() == 2 && (StringUtils.isEmpty(vo.getStartTime()) || StringUtils.isEmpty(vo.getEndTime()))) {
            return ResponseUtil.fail400("开始结束日期不可为空");
        }
        if (vo.getTimeType() == 1 && (LocalDate.parse(vo.getStartMonth() + "-01", DateTimeFormatter.ISO_LOCAL_DATE).isAfter(LocalDate.parse(vo.getEndMonth() + "-01")))) {
            return ResponseUtil.fail400("开始月份不可大于结束月份");
        }
        if (vo.getTimeType() == 1 && LocalDate.now().isBefore(LocalDate.parse(vo.getEndMonth() + "-01"))) {
            return ResponseUtil.fail400("结束月份不可大于当前月份");
        }
        if (StringUtils.isEmpty(vo.getCity())) {
            String citys = request.getHeader("allowCity");
            if (StringUtils.isNotEmpty(citys)) {
                vo.setCity(citys);
            }
        }
        return service.cleanPerCapitalOrderQuality(vo);
    }
    

    @ApiOperation(value = "打卡验收回访", httpMethod = "GET", notes = "打卡验收回访")
    @GetMapping("clockCusCp")
    @LogRecordFiled(funName = "打卡验收回访")
    public Object clockCusCp(
    		@RequestParam("city")String city,
    		@RequestParam("bookDateStart") String bookDateStart,@RequestParam("bookDateEnd")String bookDateEnd,
			@RequestParam("channel")String channel,@RequestParam("workerName")String workerName,
			@RequestParam("cpTimeStart")String cpTimeStart,@RequestParam("cpTimeEnd")String cpTimeEnd,
			@RequestParam("bookDetailId")String bookDetailId,String fraName,String goodsName,
            Boolean isExport,Boolean isCp,Boolean isClock,String degree,
            Integer page, Integer limit, HttpServletResponse response) throws Exception {
    	if(StringUtils.isNotBlank(city)&&city.equals("全国")) {
    		city=null;
    	}
    	if(StringUtils.isNotBlank(city)&&!city.contains("市")) {
    		city=city+"市";
    	}
    	if(StringUtils.isBlank(cpTimeStart)&&StringUtils.isBlank(cpTimeEnd)
    			&&StringUtils.isBlank(bookDateStart)&&StringUtils.isBlank(bookDateEnd)) {
    		return ResponseUtil.fail("工单日期和验收日期不可同时为空");
    	}
        if (isExport == null || isExport == false) {
            PageHelper.startPage(page, limit);
            List<CrmOrderBookCp> list = crmOrderBookCpMapper.getList(city,bookDateStart, bookDateEnd, channel, workerName, bookDetailId, 
            		cpTimeStart, cpTimeEnd,fraName,goodsName,isCp,isClock,degree);
            return ResponseUtil.ok(new PageInfo<>(list));
        } else {
            List<CrmOrderBookCp> list = crmOrderBookCpMapper.getList(city,bookDateStart, bookDateEnd, channel, workerName, bookDetailId, 
            		cpTimeStart, cpTimeEnd,fraName,goodsName,isCp,isClock,degree);
            ExcelUtils.exportExcel(list, null, "Sheet1", CrmOrderBookCp.class, "打卡验收回访", response);
            return null;
        }
    }
}
