package com.jzlife.report.dao.hmorder;

import java.util.List;
import java.util.Map;

import com.jzlife.report.dto.HmSalesDto;
import com.jzlife.report.dto.SaleAppDto;
import org.apache.ibatis.annotations.Param;

import com.jzlife.report.dto.export.ChannelSalesDto;
import com.jzlife.report.dto.export.CityProgressExportDto;
import com.jzlife.report.dto.export.CluePayOrderExportDto;
import com.jzlife.report.dto.export.MallDIffOrderExportDto;
import com.jzlife.report.dto.export.MonthSalesPlanExportDto;
import com.jzlife.report.dto.export.SalesReportExport;
import com.jzlife.report.dto.export.SelectClueDtoExport;
import com.jzlife.report.dto.export.ServantSignOrderExport;
import com.jzlife.report.dto.export.ServiceGMVCountExportDto;
import com.jzlife.report.dto.export.ServiceGmvExport;

public interface SalesOrderExportMapper {

	// 小程序订单
	List<SaleAppDto> selectLittleAppOrder(@Param("startDate") String startDate,
										  @Param("endDate") String endDate, @Param("channel") String channel, @Param("city") String city,
										  @Param("levelOne") String levelOne);

	// 各渠道销售明细
	List<ChannelSalesDto> selectChannelSales(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("channel") String channel, @Param("city") String city, @Param("levelOne") String levelOne);

	// 销售汇总
	List<SalesReportExport> salesSummary(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("channel") String channel, @Param("city") String city, @Param("levelOne") String levelOne);

	// 服务GMV汇总
	List<ServiceGMVCountExportDto> serviceGMVCount(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("city") String city, @Param("levelOne") String levelOne,@Param("status") String status,@Param("channel") String channel);

	// 服务GMV汇总 导出
	List<ServiceGmvExport>  serviceGMVCountExport(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("city") String city, @Param("levelOne") String levelOne,@Param("status") String status,@Param("channel") String channel);

	// 月销售进度回溯（每日）
	List<MonthSalesPlanExportDto> monthSalesPlan(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("city") String city, @Param("levelOne") String levelOne);

	// 非盒马渠道当月实销额扇形图 日期不能为空
	List<Map<String, Object>> notHMActualSales(@Param("startDate") String startDate, @Param("endDate") String endDate);

	// 线索
	List<SelectClueDtoExport> selectClue(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("resource") String resource, @Param("city") String city, @Param("serviceModel") String serviceModel);

	// 保姆签单
	List<ServantSignOrderExport> servantSignOrder(@Param("startDate") String startDate, @Param("endDate") String endDate,
			  @Param("city") String city ,@Param("remark") String remark ,@Param("serviceModel") String serviceModel);

	//支付记录
	List<CluePayOrderExportDto> cluePayOrder(@Param("startDate") String startDate, @Param("endDate") String endDate);

	//单品走势
	List<Map<String, Object>> danpingzoushi(@Param("startDate") String startDate, @Param("endDate") String endDate,
			@Param("city") String city,@Param("keyWord") String keyWord,@Param("levelOne") String levelOne,@Param("channel") String channel);

	//商品一级，二级分类字典数据
	List<String> goodsKeyWords(@Param("levelOne")String levelOne);

	//商品二级分类
	List<String> goodsLevelTwo(@Param("keyWord") String keyWord,@Param("levelOne") String levelOne,@Param("channel") String channel);

	//城市进度
	List<CityProgressExportDto> cityProgress(@Param("date") String date);

	List<MallDIffOrderExportDto>  selectDiffOrder(@Param("startDate") String startDate, @Param("endDate") String endDate);

	List<HmSalesDto>  selectHmSales(@Param("startTime") String startTime,@Param("endTime") String endTime,@Param("isExport") Boolean isExport,@Param("buyerPhone") String buyerPhone);
}
