package com.jzlife.report.dao.manager;

import com.jzlife.report.excelExport.*;
import com.jzlife.report.vo.DayReportBaseVo;
import com.jzlife.report.vo.ReportBaseVo;
import com.jzlife.report.vo.ReportStationAndShopVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface ServicePowerReportMapper {


    //工单明细
    List<Map<String, Object>> servicePowerTicketDetail(DayReportBaseVo vo);

    List<Map<String, Object>> servicePowerTicketInfo(DayReportBaseVo vo);

    List<Map<String, Object>> servicePowerServerInfo(DayReportBaseVo vo);

    List<Map<String, Object>> servicePowerStationPersonInfo(DayReportBaseVo vo);

    List<Map<String, Object>> servicePowerRentFee(ReportBaseVo vo);

    List<Map<String, Object>> servicePowerWornSubsidies(ReportBaseVo vo);

    List<Map<String, Object>> servicePowerTeacherReward(ReportBaseVo vo);

    List<Map<String, Object>> servicePowerOrderReward(ReportBaseVo vo);


    List<Map<String, Object>> selectStationAndShopStockInfo(ReportStationAndShopVo vo);

    List<Map<String, Object>> selectResidualRadio(ReportStationAndShopVo vo);

    /**
     * 查询 客诉数和服务能力 投诉
     *
     * @param city
     * @param serviceStation
     * @param s
     * @param format
     * @return
     */
    List<Map<String, Object>> selectCustomerClaimAndServerPower(@Param("city") String city, @Param("serviceStation") String serviceStation,
                                                                @Param("startTime") String s, @Param("endTime") String format);

    List<Map<String, Object>> selectCustomerClaimAndServerPowerByMonth(@Param("city") String city, @Param("serviceStation") String serviceStation,
                                                                       @Param("startMonth") String startMonth, @Param("endMonth") String endMonth);

    //当月指标
    Map<String, Object> selectCurrPowerInfo(@Param("thisDay") String format, @Param("firstDayOfMonth") String format1, @Param("lastDayOfMonth") String format2,
                                            @Param("userId") String userId, @Param("city") String city);

    //当月服务站指标
    List<Map<String, Object>> selectCurrSatationInfo(@Param("thisDay") String format, @Param("firstDayOfMonth") String format1, @Param("lastDayOfMonth") String format2,
                                                     @Param("userId") String userId, @Param("city") String city);

    //非当月指标
    Map<String, Object> selectNoCurrPowerInfo(@Param("firstDayOfMonth") String format1, @Param("lastDayOfMonth") String format2,
                                              @Param("userId") String userId, @Param("city") String city);

    //非当月服务站指标
    List<Map<String, Object>> selectNoCurrSatationInfo(@Param("firstDayOfMonth") String format1, @Param("lastDayOfMonth") String format2,
                                                       @Param("userId") String userId, @Param("city") String city);

    //##  保洁人均单量、品类人均工时
    List<Map<String, Object>> selectCleanPerCapitalOrderByMonth(@Param("city") String city, @Param("serviceStation") String serviceStation,
                                                                @Param("startMonth") String startMonth, @Param("endMonth") String endMonth, @Param("now") String now);

    List<Map<String, Object>> selectCleanPerCapitalOrderByDay(@Param("city") String city, @Param("serviceStation") String serviceStation,
                                                              @Param("startTime") String s, @Param("endTime") String format);

    // 档期满载率、人均订单、人均工时、全天班人数占比，白班人数占比
    Map<String, Object> getOtherInfo(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("userId") String userId, @Param("city") String city);

    //------ 详情报表导出用   ---//
    List<ServicePowerTicketDetailDTO> servicePowerTicketDetailNoPage(DayReportBaseVo vo);

    List<ServicePowerTicketInfoDTO> servicePowerTicketInfoNoPage(DayReportBaseVo vo);

    List<ServicePowerServerInfoDTO> servicePowerServerInfoNoPage(DayReportBaseVo vo);

    List<ServicePowerStationPersonInfoDTO> servicePowerStationPersonInfoNoPage(DayReportBaseVo vo);

    List<ServicePowerRentFeeDTO> servicePowerRentFeeNoPage(DayReportBaseVo vo);

    List<ServicePowerWornSubsidiesDTO> servicePowerWornSubsidiesNoPage(DayReportBaseVo vo);

    List<ServicePowerTeacherRewardDTO> servicePowerTeacherRewardNoPage(DayReportBaseVo vo);

    List<ServicePowerOrderRewardDTO> servicePowerOrderRewardNoPage(DayReportBaseVo vo);
}
