package com.jzlife.report.dao.reports;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.jzlife.report.dto.dto.ChannelMontOrDayGmv;
import com.jzlife.report.dto.dto.OrderLastInfo;
import com.jzlife.report.dto.dto.YearVerifyAmount;

public interface BigScreeMapper {

	//月派单量
	List<YearVerifyAmount> selectBookedByMonth(@Param("list")List<String> list);

	//获取当天订单20条或，历史当天随机2条
	List<OrderLastInfo> selectOrderLastInfo(@Param("iscurrDay")Boolean iscurrDay,
			@Param("random")Integer random,@Param("startTime")String startTime,@Param("endTime")String endTime);

	//日总销售额gmv,含退款
    BigDecimal sumPayOrder(@Param("startTime")String startTime,@Param("endTime")String endTime);

    /**
     	* 省份销售单量（地图展示）
     * @param type 0:最近30秒
     * @param type 1：最近7天
     * @return
     */
    List<Map<String, Object>> countProvinceSalesNumber(@Param("type") Integer type);


    //当月派单量
	ChannelMontOrDayGmv sumMonthProvided();
    /**
     * 月或天累计销售GMV
     * @param type 1天，2月
     * @param month
     * @param startTime
     * @param endTime
     * @return
     */
    List<ChannelMontOrDayGmv> sumMonthOrDaySales(@Param("type")Integer type,@Param("month")String month,
    		@Param("startTime")String startTime,@Param("endTime")String endTime);

    List<ChannelMontOrDayGmv> monthVerifyGmv(@Param("month")String month);

}
