package com.jzlife.report.dao.reports;

import com.jzlife.report.dto.export.SelfRebuyDetailDTO;
import com.jzlife.report.entity.reports.EtlTradeOrderBoard;
import com.jzlife.report.vo.ReBuyDetailVo;
import com.jzlife.report.vo.ReBuyQueryVo;
import com.jzlife.report.vo.SelfReBuyQueryVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface EtlTradeOrderBoardMapper {
    int deleteByPrimaryKey(String bookTradeNo);

    int insert(EtlTradeOrderBoard record);

    int insertSelective(EtlTradeOrderBoard record);

    EtlTradeOrderBoard selectByPrimaryKey(String bookTradeNo);

    int updateByPrimaryKeySelective(EtlTradeOrderBoard record);

    int updateByPrimaryKey(EtlTradeOrderBoard record);

    List<Map<String, Object>> callReBuyLine(@Param("vo") ReBuyQueryVo vo);

    List<Map<String, Object>> queryDetailByParam(@Param("vo") ReBuyDetailVo vo);

    String getSingleWarnLine();

    String getSingleNoStandardLine();

    String getCycleWarnLine();

    String getCycleNoStandardLine();

    String getCrossWarnLine();

    //查询个人维度的工单明细
    List<Map<String, Object>> queryDetailByPerson(@Param("vo") ReBuyDetailVo vo);

    String getCityByCityId(String s);

    Map<String, Object> getWorkerInfo(@Param("workerNo") String workerNo);

    List<Map<String, Object>> bookTradeOrderHistory(@Param("bookTradeOrder") String bookTradeOrder);


    Map<String,Object> queryTotalData(@Param("months") List<String> month, @Param("cityList") String cityList, @Param("fraName") String fraName);

    List<Map<String, Object>> queryEveryCityMonthTotalOrder(@Param("months") List<String> months, @Param("cityList") String cityList, @Param("type") Integer type, @Param("fraName") String fraName);

    List<Map<String, Object>> queryEveryCityMonthRebuyOrder(@Param("months") List<String> months, @Param("cityList") String cityList, @Param("type") Integer type, @Param("fraName") String fraName);

    List<String> getFraList();

    List<SelfRebuyDetailDTO> selfReBuyDetail(SelfReBuyQueryVo vo);
}
