package com.jzlife.report.entity.reports;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

@Data
public class DyLaikeShopThreeRate {
    private Integer id;

    /**
    * 批次号
    */
    @Excel(name = "批次号")
    private Integer batchId;

    /**
     * 城市id
     */
    private Integer cityId;

    /**
     * 城市名称
     */
    @Excel(name = "城市名称")
    private String cityName;

    /**
     * 开始日期
     */
    @Excel(name = "开始日期")
    private String startDate;

    /**
     * 结束日期
     */
    @Excel(name = "结束日期")
    private String endDate;

    /**
    * 门店poi_id
    */
    @Excel(name = "门店poi_id")
    private String shopPoiId;

    /**
    * 加盟商id
    */
    @Excel(name = "加盟商id")
    private Integer fraId;

    /**
    * 加盟商名称
    */
    @Excel(name = "加盟商名称")
    private String fraName;

    /**
    * 门店名
    */
    @Excel(name = "门店名")
    private String shopName;

    /**
    * 差评率
    */
    @Excel(name = "差评率")
    private BigDecimal badRate;

    /**
    * 投诉率
    */
    @Excel(name = "投诉率")
    private BigDecimal complaintRate;

    /**
    * 退款率
    */
    @Excel(name = "退款率")
    private BigDecimal refundRate;

    /**
    * 抖音侧更新评价时间
    */
    @Excel(name = "抖音侧更新时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date evaUpdateTime;
    @Excel(name = "参考时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date etlTime;
}
