package com.jzlife.report.entity.reports;

import cn.afterturn.easypoi.excel.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Date;

import lombok.Data;


@Data
@ApiModel("个人排名结果")
public class IndividualRankingDetailResult implements Serializable {
    /**
     * 商家ID
     */
    @ApiModelProperty(value = "商家ID")
    @Excel(name = "商家ID", width = 20)
    private String workerNo;

    /**
     * 姓名
     */
    @ApiModelProperty(value = "姓名")
    @Excel(name = "姓名")
    private String workerName;

    /**
     * 预约日期
     */
    @ApiModelProperty(value = "预约日期")
    @Excel(name = "预约日期", width = 20, format = "yyyy-MM-dd")
    private Date beginDate;

    /**
     * 评价类型
     */
    @ApiModelProperty(value = "评价类型")
    @Excel(name = "评价类型", width = 20)
    private String goodBad;

    /**
     *
     */
    @ApiModelProperty(value = "评价内容")
    @Excel(name = "评价内容", width = 50)
    private String comment;

    private static final long serialVersionUID = 1L;
}

