package com.jzlife.report.entity.reports;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * 订单按照地址聚合索引表
 */
@ApiModel(value = "订单按照地址聚合索引表")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class TradeOrderAddress {
    @ApiModelProperty(value = "")
    private Integer id;

    /**
     * 城市
     */
    @ApiModelProperty(value = "城市")
    private String city;

    /**
     * 区名
     */
    @ApiModelProperty(value = "区名")
    private String district;

    /**
     * 街道名
     */
    @ApiModelProperty(value = "街道名")
    private String township;

    /**
     * 街道下的住宅
     */
    @ApiModelProperty(value = "街道下的住宅")
    private String address;

    /**
     * 客户地址
     */
    @ApiModelProperty(value = "客户地址")
    private String customerAddr;

    /**
     * 客户地址经度
     */
    @ApiModelProperty(value = "客户地址经度")
    private String customerLongitude;

    /**
     * 客户地址纬度
     */
    @ApiModelProperty(value = "客户地址纬度")
    private String customerLatitude;

    /**
     * 客户地址纬度
     */
    @ApiModelProperty(value = "客户地址纬经纬度")
    private String position;

}
