package com.jzlife.report.service;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.read.listener.ReadListener;
import com.jzlife.report.dao.reports.HmScheduleOnleaveMapper;
import com.jzlife.report.dto.excelimport.HmScheduleOnleaveExcel;
import com.jzlife.report.entity.reports.HmScheduleOnleave;
import com.jzlife.report.util.DateUtil;
import com.jzlife.report.util.SpringContextUtils;
import org.springframework.beans.BeanUtils;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;

public class LeaveListener implements ReadListener<HmScheduleOnleaveExcel> {


    private String batchNo;

    private HmScheduleOnleaveMapper hmScheduleOnleaveMapper;

    private List<HmScheduleOnleave> list = new LinkedList<>();

    private int max_count = 1000;

    public LeaveListener(String times) {
        this.batchNo = times;
        hmScheduleOnleaveMapper = SpringContextUtils.getBeanByClass(HmScheduleOnleaveMapper.class);
    }

    @Override
    public void invoke(HmScheduleOnleaveExcel data, AnalysisContext context) {
        HmScheduleOnleave tempso = new HmScheduleOnleave();
        BeanUtils.copyProperties(data, tempso);
        tempso.setCreateTime(new Date());
        tempso.setBatchNo(batchNo);
        if (data.getScheduleStart() != null) {
            tempso.setScheduleStart(DateUtil.stringToDate(data.getScheduleStart(), "yyyy-MM-dd HH:mm"));
        }
        if (data.getScheduleEnd() != null) {
            tempso.setScheduleEnd(DateUtil.stringToDate(data.getScheduleEnd(), "yyyy-MM-dd HH:mm"));
        }
        list.add(tempso);
        if (list.size() >= max_count) {
            hmScheduleOnleaveMapper.batchInsert(list);
            list.clear();
        }

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        if (list.size() > 0) {
            hmScheduleOnleaveMapper.batchInsert(list);
            list.clear();
        }
        hmScheduleOnleaveMapper.filterdelete(batchNo);
    }
}
