package com.jzlife.report.service.newreport;

import com.github.pagehelper.PageInfo;
import com.jzlife.report.excelExport.DayCustomerClaimDetailDTO;
import com.jzlife.report.excelExport.ReportComplaintmanagementDTO;
import com.jzlife.report.vo.DayReportBaseVo;
import com.jzlife.report.vo.ReportBaseVo;
import com.jzlife.report.vo.ReportCustomerClaimAndPowerVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


public interface ServiceQualityReportService {


    /**
     * 返回服务质量看板中的 客诉率堆叠折线图 & 整体客诉率& 保洁客诉率 & 品类客诉率
     *
     * @param vo
     * @return
     */
    Map<String, Object> serviceQualityStackLine(ReportBaseVo vo);

    /**
     * 客诉信息 汇总  现存客诉单、平均处理时长、S级工单数、超时工单数、 IB接听率
     * 保洁&品类 分类 饼图 (一级和二级 )
     *
     * @return
     */
    Map<String, Object> claimSummaryAndPie();

    /**
     * 查看客诉明细
     *
     * @param vo
     * @return
     */
    PageInfo<Map<String, Object>> dayCustomerClaimDetail(DayReportBaseVo vo);

    /**
     * 在线客服报表-明细
     *
     * @param pageNo
     * @param pageSize
     * @param startDate
     * @param endDate
     * @return
     */
    Object onlineChatSummary(Integer pageNo, Integer pageSize, String startDate,
			String endDate, String customerId, String userName,Boolean isExport );


    Map<String, Object> customerClaimAndServicePowerLineGraph(ReportCustomerClaimAndPowerVo vo);

    /**
     * 在线客服报表汇总
     *
     * @param pageNo
     * @param pageSize
     * @param startDate
     * @param endDate
     * @param userName
     * @return
     */
    Object onlineChathz(Integer pageNo, Integer pageSize, String startDate,
			String endDate, String userName,Boolean isExport );

    List<DayCustomerClaimDetailDTO> dayCustomerClaimDetailNoPage(@Param("baseVo") DayReportBaseVo baseVo);

    List<ReportComplaintmanagementDTO> complaintManagementExport(String city, String serviceStation, String serverName, String ticketSn, String hemaWorkOrder, String startTime, String endTime);

    PageInfo<ReportComplaintmanagementDTO> complaintManagement(String city, String serviceStation, String serverName, String ticketSn, String hemaWorkOrder, String startTime, String endTime, String pageNo, String pageSize);
    
    Object onceFilingTicket(Integer pageNo, Integer pageSize, String startDate, String endDate, String city,
			 Boolean isExport);
}
