package com.jzlife.report.service.newreport.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jzlife.report.dao.manager.ServiceSalaryReportMapper;
import com.jzlife.report.dao.reports.SPMapper;
import com.jzlife.report.dao.reports.ServiceReportMapper;
import com.jzlife.report.dto.*;
import com.jzlife.report.service.newreport.ServiceReportService;
import com.jzlife.report.vo.DayReportBaseVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
@Slf4j
public class ServiceReportServiceImpl implements ServiceReportService {

	@Autowired
	private ServiceSalaryReportMapper serviceSalaryReportMapper;

	@Autowired
	private SPMapper spMapper;

	@Autowired
	private ServiceReportMapper serviceReportMapper;


	@Override
	public List<ReportServiceSalary> serviceSalaryList(DayReportBaseVo vo) {

		List<ReportServiceSalary> list = serviceSalaryReportMapper.serviceSalaryList(
				vo.getCity(),
				vo.getServiceStation(),
				vo.getWorkerName(),
				vo.getMonth(),
				vo.getStartPage(),
				vo.getLimit());

		return list;
	}

	@Override
	public List<ReportServiceRebuy> serviceRebuyList(DayReportBaseVo vo) {
		return spMapper.reportServiceRebuy(vo.getStartTime(),vo.getEndTime(), vo.getCity(), vo.getServiceStation(),vo.getMobile(), vo.getStartPage(), vo.getLimit());
	}

	@Override
	public List<ReportServiceRebuy> serviceRebuyDetailList(DayReportBaseVo vo) {
		return spMapper.reportServiceRebuyDetail(vo.getStartTime(),vo.getEndTime(), vo.getCity(), vo.getServiceStation(),vo.getMobile(), vo.getStartPage(), vo.getLimit());
	}

	@Override
	public List<ReportServiceRebuy> serviceRebuyPLDetailList(DayReportBaseVo vo) {
		return spMapper.reportServiceRebuyPLDetail(vo.getStartTime(),vo.getEndTime(), vo.getCity(), vo.getServiceStation(),vo.getMobile(), vo.getStartPage(), vo.getLimit());
	}

	@Override
	public  List<ReportOldCustomerRebuyDetail> serviceOldCustomerRebuyDetailList(DayReportBaseVo vo){
		return spMapper.reportServiceOldCustomerRebuyDetail(vo.getStartTime(),vo.getEndTime(),vo.getCity(),vo.getMobile(),vo.getStartPage(),vo.getLimit());
	}


	@Override
	public List<ReportNewCustomerTradeDetail> serviceNewCustomerTradeDetail(DayReportBaseVo vo,String type) {
		return spMapper.serviceNewCustomerTradeDetail(vo.getStartTime(), vo.getCity(), type,vo.getMobile(), vo.getStartPage(), vo.getLimit());
	}

	@Override
	public Object  serviceCycleTradeDetail(DayReportBaseVo vo,Boolean isExport){
		if(isExport){
			return serviceReportMapper.serviceCycleTradeDetail(vo.getStartTime(), vo.getCity());
		}
		else {
			PageHelper.startPage(vo.getStartPage(), vo.getLimit());
			List<ReportCycleTradeDetail> list = serviceReportMapper.serviceCycleTradeDetail(vo.getStartTime(), vo.getCity());
			return new PageInfo<>(list);
		}
	}

	@Override
	public String getEtlTime(){
		return spMapper.getEtlTime("select DATE_FORMAT(max(update_time),'%Y-%m-%d %H:%i') from trade_order");
	}
}
