package com.jzlife.report.service.report;

import com.jzlife.report.dto.*;
import com.jzlife.report.dto.douyin.BookVerifyDetailVo;
import com.jzlife.report.dto.douyin.DouyinBookTotalByFraVo;
import com.jzlife.report.dto.douyin.DouyinVerifyDetailByTanletVo;
import com.jzlife.report.dto.douyin.DouyinVerifyDetailFraVo;

import java.util.List;

public interface OrderReservationVerificationService {
    List<OrderReservationRateDto> getOrderReservationRate(OrderReservationQueryDto queryDto);

    List<RefundAfterReservationDto> getRefundAfterReservation(OrderReservationQueryDto queryDto);

    List<VerificationRateWeekDto> getVerificationRateWeek(OrderReservationQueryDto queryDto);

    List<VerificationRateMonthDto> getVerificationRateMonth(OrderReservationQueryDto queryDto);

    List<ContactOrderDto> getContactOrder(OrderReservationQueryDto queryDto);


    List<RefundAfterBookDateDto> getRefundAfterByBookDate(OrderReservationQueryDto queryDto);


    /**
     * 核销明细表
     * @param queryDto
     * @return
     */
    List<DouyinVerifyDetailFraVo> getVerifyDetailByBookDate(OrderReservationQueryDto queryDto);


    //核销明细表（达人维度）
    List<DouyinVerifyDetailByTanletVo> getVerifyDetailByTanlet(OrderReservationQueryDto queryDto);


    //核销预约明细表
    List<BookVerifyDetailVo> getVerifyDetailList(OrderReservationQueryDto queryDto);

    //预约汇总by加盟商
    List<DouyinBookTotalByFraVo> getBookTotalByFra(OrderReservationQueryDto queryDto);
}
