package com.jzlife.report.util.excel;

import com.alibaba.excel.converters.Converter;
import com.alibaba.excel.enums.CellDataTypeEnum;
import com.alibaba.excel.metadata.GlobalConfiguration;
import com.alibaba.excel.metadata.data.ReadCellData;
import com.alibaba.excel.metadata.property.ExcelContentProperty;
import com.jzlife.report.util.DateUtil;

import java.util.Date;

/**
 * @ClassName LocalDateTimeConverter
 * @Description EasyExcel Date转换器
 **/
public class DateConverter implements Converter<Date> {


    @Override
    public Class supportJavaTypeKey() {
        return Date.class;
    }

    @Override
    public CellDataTypeEnum supportExcelTypeKey() {
        return CellDataTypeEnum.DATE;
    }

    @Override
    public Date convertToJavaData(ReadCellData<?> cellData, ExcelContentProperty contentProperty,
                                  GlobalConfiguration globalConfiguration) throws Exception {

        String stringValue = cellData.getStringValue();
        if (stringValue == null || stringValue.trim().length() == 0) {
            return null;
        }

        if (stringValue.length() == 17) {
            return DateUtil.stringToDate(stringValue, "yyyy-MM-dd H:m:s");
        }

        // YYYY-mm-dd
        return DateUtil.stringToDate(cellData.getStringValue(), "YYYY-mm-dd");

//		return Converter.super.convertToJavaData(cellData, contentProperty, globalConfiguration);
    }

//	@Override
//	public Date convertToJavaData(CellData cellData, ExcelContentProperty excelContentProperty,
//			GlobalConfiguration globalConfiguration) throws Exception {
//		String stringValue = cellData.getStringValue();
//		if (stringValue == null||stringValue.trim().length()==0) {
//			return null;
//		}
//
//		if(stringValue.contains("/")) {
//			return DateUtil.stringToDate(stringValue,"yyyy/MM/dd H:m:s");
//		}
//
//		// YYYY-mm-dd
//		return DateUtil.stringToDate(cellData.getStringValue(),"YYYY-mm-dd");
//	}

}
