package com.jzlife.report.util.excel;

import java.util.Date;

import com.alibaba.excel.converters.Converter;
import com.alibaba.excel.enums.CellDataTypeEnum;
import com.alibaba.excel.metadata.GlobalConfiguration;
import com.alibaba.excel.metadata.data.CellData;
import com.alibaba.excel.metadata.data.ReadCellData;
import com.alibaba.excel.metadata.property.ExcelContentProperty;
import com.jzlife.report.util.DateUtil;

/**
 * @ClassName LocalDateTimeConverter
 * @Description EasyExcel Time转换器 HH:mm:ss
 **/
public class TimeConverter implements Converter<Date> {


	@Override
	public Class supportJavaTypeKey() {
		return Date.class;
	}

	@Override
	public CellDataTypeEnum supportExcelTypeKey() {
		return CellDataTypeEnum.DATE;
	}
	
	@Override
	public Date convertToJavaData(ReadCellData<?> cellData, ExcelContentProperty contentProperty,
			GlobalConfiguration globalConfiguration) throws Exception {
		
		String stringValue = cellData.getStringValue();
		if (stringValue == null || stringValue.trim().length() != 8) {
			return null;
		}
		// YYYY-mm-dd
		return DateUtil.stringToDate(cellData.getStringValue().trim(),"hh:mm:ss");
		
//		return Converter.super.convertToJavaData(cellData, contentProperty, globalConfiguration);
	}

//	public Date convertToJavaData(CellData cellData, ExcelContentProperty excelContentProperty,
//			GlobalConfiguration globalConfiguration) throws Exception {
//		String stringValue = cellData.getStringValue();
//		if (stringValue == null || stringValue.trim().length() != 8) {
//			return null;
//		}
//		// YYYY-mm-dd
//		return DateUtil.stringToDate(cellData.getStringValue().trim(),"HH:mm:ss");
//	}

}