package com.jzlife.report.vo;


import com.alibaba.excel.annotation.ExcelProperty;
import com.jzlife.report.anno.ExcelFiled;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class DaysStackRadioVo {

    /**
     * 时间，格式20211221
     */
    @ExcelFiled(colName = "日期", dateFormat = "yyyyMMdd")
    @ExcelProperty(value = "日期", index = 0)
    private String date;

    /**
     * 城市
     */
    @ExcelFiled(colIndex = 1, colName = "城市")
    @ExcelProperty(value = "城市", index = 1)
    private String city;

    /**
     * 服务站类型  保洁站、品类站
     */
    @ExcelFiled(colIndex = 2, colName = "服务站类型")
    @ExcelProperty(value = "服务站类型", index = 2)
    private String stationType;

    /**
     * 服务站名称
     */
    @ExcelFiled(colIndex = 3, colName = "服务站")
    @ExcelProperty(value = "服务站", index = 3)
    private String stationName;

    /**
     * 当日服务者数量
     */
    @ExcelFiled(colIndex = 4, colName = "当日服务者数量")
    @ExcelProperty(value = "当日服务者数量", index = 4)
    private String currentDayServerCount;

    /**
     * 当日空闲服务者数量
     */
    @ExcelFiled(colIndex = 5, colName = "当日可接单服务者数量")
    @ExcelProperty(value = "当日可接单服务者数量", index = 5)
    private Integer currentDayLeisureServerCount;

    /**
     * 当日库存资源数
     */
    @ExcelFiled(colIndex = 6, colName = "当日资源库存数")
    @ExcelProperty(value = "当日资源库存数", index = 6)
    private Integer currentDaySourceCount;


    /**
     * 当日已被占用资源数
     */
    @ExcelFiled(colIndex = 7, colName = "已被占用库存数")
    @ExcelProperty(value = "已被占用库存数", index = 7)
    private Integer currentDayUsedSourceCount;
    /**
     * 当日可用库存数
     */
    @ExcelFiled(colIndex = 8, colName = "可约库存数")
    @ExcelProperty(value = "可约库存数", index = 8)
    private Integer currentDayLeisureSourceCount;

    /**
     * 当日库存率
     */
    @ExcelFiled(colIndex = 9, colName = "库存剩余率", precision = 4)
    @ExcelProperty(value = "库存剩余率", index = 9)
    private String statckRadio;



    private Integer batchId;

    private Date importDate;

}
