package com.jzlife.report.vo;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ReportCustomerClaimAndPowerVo {

    @ApiModelProperty(value = "城市名称，支持多选，【,】分割")
    private String city;


    @ApiModelProperty(value = "开始时间", notes = "时间格式为 yyyy-MM")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-(0[1-9]|1[0-9]|2[0-9]|3[01])$", message = "开始日期不合法")
    private String startTime;

    @ApiModelProperty(value = "结束时间", notes = "时间格式为 yyyy-MM-dd")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])-(0[1-9]|1[0-9]|2[0-9]|3[01])$", message = "结束日期不合法")
    private String endTime;


    @ApiModelProperty(value = "服务站名称", notes = "服务站名称")
    private String serviceStation;

    @ApiModelProperty(value = "开始页", notes = "开始页")
    private Integer startPage = 1;
    @ApiModelProperty(value = "每页展示条数", notes = "每页展示条数")
    private Integer limit = 50;


    @ApiModelProperty(value = "时间类型", notes = "时间类型 1 月 2 天")
    @Max(value = 2, message = "时间类型非法")
    @Min(value = 1, message = "时间类型非法")
    @NotNull(message = "时间类型不可为空")
    private Integer timeType;


    @ApiModelProperty(value = "开始月份", notes = "时间格式  yyyy-MM")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])$", message = "开始月份不合法")
    private String startMonth;


    @ApiModelProperty(value = "结束月份", notes = "时间格式 yyyy-MM")
    @Pattern(regexp = "^20(19|2\\d)-(0[1-9]|1[012])$", message = "结束月份不合法")
    private String endMonth;


}
